#!/bin/sh
#!/bin/bash
# simple Bash Menu Script by jackluke

printf '\e[96m;%s\a' "$color"
printf "$'\e[40m'Catalina OTA Software update beta fix by jackluke"
printf "\n\n\n"
clear && printf '\e[3J'
echo "Welcome to the Catalina OTA Software update beta fix"
echo "\nDetecting your OTA dist file"
if [ -e /Library/Updates/*-*/*-*.dist ]
then
echo "\nYour OTA dist file is correctly detected"
echo "\nCatalina OTA Software update beta fix can't be executed as standard user if you want to suspend the script just press CTRL+Z"
echo "\nto apply this fix your current account password is required\notherwise the script can't process\n"
echo "\nSetting nvram parameter to enforce AMFI compatibility check"
sudo mount -uw / ; killall Finder
sudo nvram boot-args="-no_compat_check amfi_get_out_of_my_way=1"
diskutil mount Preboot
sudo perl -i -pe 's/>-no_compat_check/>amfi_get_out_of_my_way=1 -no_compat_check/' /Volumes/Preboot/*/Library/Preferences/SystemConfiguration/com.apple.Boot.plist
sudo defaults write /Library/Preferences/com.apple.security.libraryvalidation.plist DisableLibraryValidation -bool true
echo "\nChecking library validation"
sudo defaults read /Library/Preferences/com.apple.security.libraryvalidation.plist
echo "\nDone\nAny AMFI compatibility check is applied to Catalina"
echo "\nDetecting machine board id\n"
Macmid="$(sysctl -n hw.model)";
echo "\nYour machine model is ${Macmid}\n"
Macmidswap='s/\'${Macmid}'/MacExample7,0/';
Boardid="$(ioreg -l | grep "board-id" | awk -F\" '{print $4}')";
echo "\nYour machine board number is ${Boardid}\n"
Boardidswap='s/Mac-9AE82516C7C6B903/\'${Boardid}'/';
OTAdist="$(ls -l /Library/Updates/*-*/*-*.dist)";
OTAinstallcheck='s/var\sboardIds/return\ttrue;\tvar\tboardIds/';
cd /Library/Updates/*-*/
echo "\nPlease re-type password when required\n"
echo "\nPatching the OTA dist file\n${OTAdist}"
sudo perl -i -pe ${OTAinstallcheck} /Library/Updates/*-*/*-*.dist
echo "\nDone"
echo "\nLet the OTA update to complete through its automatic phases, after apply the known Catalina post patches\n"
else
echo "\n the Catalina OTA dist is not yet ready or downloaded\nCheck again your Software Update panel if a new update is available and start to Download the OTA update clicking the Update Now button, then after a minute retry this script\n"
fi